<%@ page import="java.util.ArrayList" %>
<%@ page import="org.wso2.carbon.identity.relyingparty.ui.client.AuthenticationServiceClient" %>
<%@ page import="org.wso2.carbon.identity.relyingparty.ui.dto.InfoCardSignInDTO" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.identity.relyingparty.ui.client.RelyingPartyServiceClient" %>
<%@ page import="org.wso2.carbon.identity.relyingparty.ui.dto.InfoCardDTO" %>
<%@ page import="org.wso2.carbon.identity.relyingparty.ui.util.TokenDecrypter" %>
<%@ page import="org.w3c.dom.Element" %>
<%@ page import="java.io.StringWriter" %>
<%@ page import="org.apache.xml.serialize.XMLSerializer" %>
<%@ page import="org.apache.xml.serialize.OutputFormat" %>
<%@ page import="org.wso2.carbon.identity.relyingparty.ui.dto.OpenIDDTO" %>

<%
    String cssLocation = request.getParameter("css");
    if ("null".equals(cssLocation)) {
        cssLocation = null;
    }

    if (cssLocation != null) {
        cssLocation = URLDecoder.decode(cssLocation, "UTF-8");
    }

    String pageTitle = request.getParameter("title");

    String forwardPage = request.getParameter("forwardPage");
    if (forwardPage != null) {
        forwardPage = URLDecoder.decode(forwardPage, "UTF-8");
        session.setAttribute("forwardPage", forwardPage);
    }

    String xmlToken = request.getParameter("xmlToken");
    String forwardTo = null;
    OpenIDDTO openID = (OpenIDDTO) session.getAttribute("openId");
    String BUNDLE = "org.wso2.carbon.identity.relyingparty.ui.i18n.Resources";
    ResourceBundle resourceBundle = ResourceBundle.getBundle(BUNDLE, request.getLocale());

    if (xmlToken != null) {
        Element element = TokenDecrypter.decryptToken(xmlToken);

        OutputFormat format = new OutputFormat();
        StringWriter sw = new StringWriter();
        XMLSerializer serializer = new XMLSerializer(sw, format);
        serializer.serialize(element);
        String stringToken = sw.toString();

        String serverURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
        ConfigurationContext configContext =
                (ConfigurationContext) config.getServletContext()
                        .getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
        String cookie = null;

        try {
            RelyingPartyServiceClient client =
                    new RelyingPartyServiceClient(cookie, serverURL, configContext);
            InfoCardDTO infoCard = new InfoCardDTO();
            InfoCardSignInDTO signin = null;
            infoCard.setXmlToken(stringToken);

            signin = client.signInWithInfoCard(infoCard);
            OpenIDDTO openIdDto = new OpenIDDTO();
            openIdDto.setUserName(signin.getUserID());
            openIdDto.setOpenID(openID.getOpenID());
            boolean status = client.addOpenIDToProfile(openIdDto);

            if (status) {
                String message = resourceBundle.getString("openid.added.to.profile");
                CarbonUIMessage.sendCarbonUIMessage(message, CarbonUIMessage.INFO, request);
                forwardTo = "index.jsp?region=region1&item=infocard_sign_in";

                if (forwardPage != null) {
                    forwardTo = "index.jsp?forwardPage=" + URLEncoder.encode(forwardPage, "UTF-8") +
                            "&css=" + URLEncoder.encode(cssLocation, "UTF-8") + "&title=" +
                            URLEncoder.encode(pageTitle, "UTF-8");
                }

            } else {
                String message = resourceBundle.getString("unable.to.signin.please.try.again");
                CarbonUIMessage.sendCarbonUIMessage(message, CarbonUIMessage.ERROR, request);
                forwardTo = "openid_sign_in.jsp";

                if (forwardPage != null) {
                    forwardTo = "openid_sign_in.jsp?forwardPage=" +
                            URLEncoder.encode(forwardPage, "UTF-8") +
                            "&css=" + URLEncoder.encode(cssLocation, "UTF-8") + "&title=" +
                            URLEncoder.encode(pageTitle, "UTF-8");
                }
            }
        } catch (Exception e) {
            String message = resourceBundle.getString("information.card.not.accepted");
            CarbonUIMessage.sendCarbonUIMessage(message, CarbonUIMessage.ERROR, request);
            forwardTo = "index.jsp?region=region1&item=infocard_sign_in";

            if (forwardPage != null) {
                forwardTo = "index.jsp?forwardPage=" + URLEncoder.encode(forwardPage, "UTF-8") +
                        "&css=" + URLEncoder.encode(cssLocation, "UTF-8") + "&title=" +
                        URLEncoder.encode(pageTitle, "UTF-8");
            }

        }
    } else {
        String message = resourceBundle.getString("information.card.not.accepted");
        CarbonUIMessage.sendCarbonUIMessage(message, CarbonUIMessage.ERROR, request);
        forwardTo = "index.jsp?region=region1&item=infocard_sign_in";

        if (forwardPage != null) {
            forwardTo = "index.jsp?forwardPage=" + URLEncoder.encode(forwardPage, "UTF-8") +
                    "&css=" + URLEncoder.encode(cssLocation, "UTF-8") + "&title=" +
                    URLEncoder.encode(pageTitle, "UTF-8");
        }
    }
%>


<%@page import="java.util.ResourceBundle" %>
<%@ page import="java.net.URLDecoder" %>
<%@ page import="java.net.URLEncoder" %>
<script type="text/javascript">
    function forward() {
        location.href = "<%=forwardTo%>";
    }
</script>

<script type="text/javascript">
    forward();
</script>
